# Class: Signal

## Phaser. Signal

A Signal is used for object communication via a custom broadcaster instead of Events.

#### new Signal()

  Author:
    - Miller Medeiros http://millermedeiros.github.com/js-signals/
  Source:
    - core/Signal.js, line 13

### Members

#### active

  If Signal is active and should broadcast events.

  <p><strong>IMPORTANT:</strong> Setting this property during a dispatch will only affect the next dispatch, if you want to stop the propagation of a signal use `halt()` instead.</p>

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `active` | boolean |

  Default Value:
    - true
  Source:
    - core/Signal.js, line 61

#### memorize

  If Signal should keep record of previously dispatched parameters and automatically execute listener during `add()`/`addOnce()` if Signal was already dispatched before.

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `memorize` | boolean |

  Source:
    - core/Signal.js, line 47

### Methods

#### add(listener, listenerContext, priority) → {Phaser.SignalBinding}

  Add a listener to the signal.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `listener` | function |  | Signal handler function.
  `listenerContext` | object | <optional> | Context on which listener will be executed (object that should represent the `this` variable inside listener function).
  `priority` | number | <optional> | The priority level of the event listener. Listeners with higher priority will be executed before listeners with lower priority. Listeners with same priority level will be executed at the same order as they were added. (default = 0).

  Source:
    - core/Signal.js, line 148

  ##### Returns:

  An Object representing the binding between the Signal and listener.

  Type
    Phaser.SignalBinding

#### addOnce(listener, listenerContext, priority) → {Phaser.SignalBinding}

  Add listener to the signal that should be removed after first execution (will be executed only once).

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `listener` | function |  | Signal handler function.
  `listenerContext` | object | <optional> | Context on which listener will be executed (object that should represent the `this` variable inside listener function).
  `priority` | number | <optional> | The priority level of the event listener. Listeners with higher priority will be executed before listeners with lower priority. Listeners with same priority level will be executed at the same order as they were added. (default = 0)

  Source:
    - core/Signal.js, line 162

  ##### Returns:

  An Object representing the binding between the Signal and listener.

  Type
    Phaser.SignalBinding

#### dispatch(params)

  Dispatch/Broadcast Signal to all listeners added to the queue.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `params` | any | <optional> | Parameters that should be passed to each handler.

  Source:
    - core/Signal.js, line 234

#### dispatch()

  ##### Properties:

  Name | Type | Description
  --- | --- | ---
  `dispatch` | function | The dispatch function is what sends the Signal out.

  Source:
    - core/Signal.js, line 33

#### dispose()

  Remove all bindings from signal and destroy any reference to external objects (destroy Signal object). IMPORTANT: calling any method on the signal instance after calling dispose will throw errors.

  Source:
    - core/Signal.js, line 281

#### forget()

  Forget memorized arguments.

  Source:
    - core/Signal.js, line 271
  See:
    - Signal.memorize

#### getNumListeners() → {number}

  Gets the total number of listeneres attached to ths Signal.

  Source:
    - core/Signal.js, line 213

  ##### Returns:

  Number of listeners attached to the Signal.

  Type
    number

#### halt()

  Stop propagation of the event, blocking the dispatch to next listeners on the queue. IMPORTANT: should be called only during signal dispatch, calling it before/after dispatch won't affect signal broadcast.

  Source:
    - core/Signal.js, line 223
  See:
    - Signal.prototype.disable

#### has(listener, context) → {boolean}

  Check if listener was attached to Signal.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `listener` | function |  | Signal handler function.
  `context` | Object | <optional> | Context on which listener will be executed (object that should represent the `this` variable inside listener function).

  Source:
    - core/Signal.js, line 136

  ##### Returns:

  If Signal has the specified listener.

  Type
    boolean

#### remove(listener, context) → {function}

  Remove a single listener from the dispatch queue.

  ##### Parameters:

  Name | Type | Argument | Description
  --- | --- | --- | ---
  `listener` | function |  | Handler function that should be removed.
  `context` | object | <optional> | Execution context (since you can add the same handler multiple times if executing in a different context).

  Source:
    - core/Signal.js, line 176

  ##### Returns:

  Listener handler function.

  Type
    function

#### removeAll()

  Remove all listeners from the Signal.

  Source:
    - core/Signal.js, line 200

#### toString() → {string}

  Source:
    - core/Signal.js, line 293

  ##### Returns:

  String representation of the object.

  Type
    string